#ifndef	   ACT_OZIP_GTK_USER_INTERFACE_H_INCLUDED
#define	   ACT_OZIP_GTK_USER_INTERFACE_H_INCLUDED

// Author:		H. Shimora
// Created:		Mar 15 2001
// Version:		0.00

///-----------------------------------------------
/// Change Log:
///-----------------------------------------------
// version 0.00  Mar 15 2001    base version.
//
//

#include  "action_basic.h"
#include  "gtk_interface_architecture.h"
#include  "gtk_interface_controller.h"
#include  "interactive_window.h"
#include  <utility>

class  Act_Ozip_Gtk_User_Interface : public Soccer_Action
{
protected:
	ref_count_ptr<Interactive_Window>		presentation;
	ref_count_ptr<Gtk_Interface_Architecture>	architecture;
	ref_count_ptr<Gtk_Interface_Controller>		controller;

protected:
	Command_Queue	q;

public:
		 Act_Ozip_Gtk_User_Interface
			 ( const Field_Recog_Interface & ,
			   bool  handle_gtk_event ,
			   bool  true_view ,
			   int  valid_player_threshold ,
			   double  base_player_size ,
			   double  player_size_rate ,
			   double  burn_out ,
			   const std::pair<int, int> &  window_size );

	virtual	~Act_Ozip_Gtk_User_Interface();

	virtual	ref_count_ptr<Soccer_Action>	copy() const;
	virtual	bool				finished() const;
	virtual	Soccer_Composite_Command	action();
};


#endif	/* ACT_OZIP_GTK_USER_INTERFACE_H_INCLUDED */
